
#include "FMODmike.h"
#include "GLfunctions.h"



int main(int argc, char *argv[])
{
	
	
	//initialise GLUT
	glutInit(&argc,argv);	

	//Initialise display mode:double buffer, RGB mode, depth buffer, alpha channel
	glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGBA|GLUT_DEPTH|GLUT_ALPHA);

	//WINDOW MODE
	//choose window size
	glutInitWindowSize(640,512);

	//create window
	glutCreateWindow("---===LIVIZ: Live music visualiation===---");
		
	//set function to call when window displays
	glutDisplayFunc(draw);

	//set reshape funtion
	glutReshapeFunc(reshape);

	//set idle func
	glutIdleFunc(idle);

	// run our custom initialisation
	onInit();

	// set the function to be called when we exit
	atexit(onExit);

	// this function runs a while loop to keep the program running.
	glutMainLoop();

	
	return 0;

}