#include "GLvisuals.h"

//-----------------------------------------------
//c_visuals_01 class functions
//-----------------------------------------------

c_visuals_01::c_visuals_01()
{
	rotate = 0;
}


//The following code draws the shapes that respond the the microphone input.  
//The function takes a pointer to the input deviceas a parameter so it can access
//the required values.

void c_visuals_01::runVisual(c_driver* device)
{
		

/*	
Attempt at drawing a line representing oscilloscope, though the callback function didnt work properly


	//curve to represent oscilloscope
	glPushMatrix();
	glBegin(GL_LINE_STRIP);

	for(int i = 0;i < 256; i++)
	{
		glColor3f(1.0, 0.0 ,0.0);
		glNormal3f(0,0,1);
		glVertex3f(-5.12 + i*.04,device->getOscVal(i) + 1.5,0);
		//cout << device->getOscVal(i);
	}
	cout << endl << endl;

	glEnd();
	glPopMatrix();
*/
	
	
	
	//-------------------------------------------------------------------------------------
	//SOLID: for transparency to work, need to draw solid objects before transparent ones
	//-------------------------------------------------------------------------------------
	
	//Draws square of lil spheres reactin to spectrum, copied twice more, and revolving
	float i;

	for(int j = 0; j<3; ++j)
	{
		for(i = 0;i<64;++i)
		{
			glPushMatrix();
				
			GLfloat mat_solid[] = { i/64, 0.0, 1-(i/64), 1.0 };
			GLfloat mat_zero[] = { 0.0, 0.0, 0.0, 1.0 };			
			
			glRotatef(rotate,1,0,0);
			glRotatef(60*j,0,1,0);
			glTranslatef(-5.12 + i*0.08,device->getSpectrumVal(i)*50-3.5,0);

			glMaterialfv(GL_FRONT, GL_EMISSION, mat_zero);
			glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_solid);

			glutSolidSphere(.1,5,5);

			

			glPopMatrix();
		}

		for(i = 0;i<64;++i)
		{
			glPushMatrix();
				
			GLfloat mat_solid[] = { i/64, 0.0, 1-(i/64), 1.0 };
			GLfloat mat_zero[] = { 0.0, 0.0, 0.0, 1.0 };
			
			glRotatef(rotate,1,0,0);
			glRotatef(60*j,0,1,0);
			glTranslatef(5.12 - i*0.08,device->getSpectrumVal(i)*50-3.5,0);
			
			glMaterialfv(GL_FRONT, GL_EMISSION, mat_zero);
			glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_solid);

			glutSolidSphere(.1,5,5);

			glPopMatrix();
		}



		for(i = 0;i<64;++i)
		{
			glPushMatrix();
				
			GLfloat mat_solid[] = { i/64, 0.0, 1-(i/64), 1.0 };
			GLfloat mat_zero[] = { 0.0, 0.0, 0.0, 1.0 };
			
			glRotatef(rotate,1,0,0);
			glRotatef(60*j,0,1,0);
			glTranslatef(-5.12 + i*0.08,device->getSpectrumVal(i)*-50+3.5,0);
			
			glMaterialfv(GL_FRONT, GL_EMISSION, mat_zero);
			glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_solid);

			glutSolidSphere(.1,5,5);

			glPopMatrix();
		}

		for(i = 0;i<64;++i)
		{
			glPushMatrix();
				
			GLfloat mat_solid[] = { i/64, 0.0, 1-(i/64), 1.0 };
			GLfloat mat_zero[] = { 0.0, 0.0, 0.0, 1.0 };
			
			glRotatef(rotate,1,0,0);
			glRotatef(60*j,0,1,0);
			glTranslatef(5.12 - i*0.08,device->getSpectrumVal(i)*-50+3.5,0);
			
			glMaterialfv(GL_FRONT, GL_EMISSION, mat_zero);
			glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_solid);

			glutSolidSphere(.1,5,5);

			glPopMatrix();
		}
	




		for(i = 0;i<64;++i)
		{
			glPushMatrix();
				
			GLfloat mat_solid[] = { i/64, 0.0, 1-(i/64), 1.0 };
			GLfloat mat_zero[] = { 0.0, 0.0, 0.0, 1.0 };
			
			glRotatef(rotate,1,0,0);
			glRotatef(60*j,0,1,0);
			glTranslatef(device->getSpectrumVal(i)*50-3.5,5.12 - i*0.08,0);
			
			glMaterialfv(GL_FRONT, GL_EMISSION, mat_zero);
			glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_solid);

			glutSolidSphere(.1,5,5);

			glPopMatrix();
		}

		for(i = 0;i<64;++i)
		{
			glPushMatrix();
				
			GLfloat mat_solid[] = { i/64, 0.0, 1-(i/64), 1.0 };
			GLfloat mat_zero[] = { 0.0, 0.0, 0.0, 1.0 };
			
			glRotatef(rotate,1,0,0);
			glRotatef(60*j,0,1,0);
			glTranslatef(device->getSpectrumVal(i)*50-3.5,-5.12 + i*0.08,0);
			
			glMaterialfv(GL_FRONT, GL_EMISSION, mat_zero);
			glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_solid);

			glutSolidSphere(.1,5,5);

			glPopMatrix();
		}




		for(i = 0;i<64;++i)
		{
			glPushMatrix();
				
			GLfloat mat_solid[] = { i/64, 0.0, 1-(i/64), 1.0 };
			GLfloat mat_zero[] = { 0.0, 0.0, 0.0, 1.0 };
			
			glRotatef(rotate,1,0,0);
			glRotatef(60*j,0,1,0);
			glTranslatef(device->getSpectrumVal(i)*-50+3.5,5.12 - i*0.08,0);
			
			glMaterialfv(GL_FRONT, GL_EMISSION, mat_zero);
			glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_solid);

			glutSolidSphere(.1,5,5);

			glPopMatrix();
		}

		for(i = 0;i<64;++i)
		{
			glPushMatrix();
				
			GLfloat mat_solid[] = { i/64, 0.0, 1-(i/64), 1.0 };
			GLfloat mat_zero[] = { 0.0, 0.0, 0.0, 1.0 };
			
			glRotatef(rotate,1,0,0);
			glRotatef(60*j,0,1,0);
			glTranslatef(device->getSpectrumVal(i)*-50+3.5,-5.12 + i*0.08,0);
			
			glMaterialfv(GL_FRONT, GL_EMISSION, mat_zero);
			glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_solid);

			glutSolidSphere(.1,5,5);

			glPopMatrix();
		}
	}

	//change angle of spheres to give appearance of camera rotating
	rotate += 1.0;


	//-------------------------------------------------------------
	//TRANSPARENT
	//-------------------------------------------------------------

	//draw circles, radius representing Spectrum values
	
	GLfloat mat_transparent[] = { 0.0, 0.0, 0.8, 0.6 };
	GLfloat mat_emission[] = { 0.0, 0.0, 0.3, 0.6 };				

	
	for(i=0; i<64; ++i)
	{			
		glPushMatrix();

		
		glTranslatef(-5.12 + i*0.08, 0, 0);
		glScalef(0,0.1 + device->getSpectrumVal(i)*10,0.1 + device->getSpectrumVal(i)*10 );
		
		glMaterialfv(GL_FRONT, GL_EMISSION, mat_emission);
		glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_transparent);
		glEnable (GL_BLEND);
		glDepthMask (GL_FALSE);
		glBlendFunc (GL_SRC_ALPHA, GL_ONE);

		glutSolidSphere(1,20,20);

		glDepthMask (GL_TRUE);
		glDisable (GL_BLEND);

		glPopMatrix();
		  
	}

	
	
	for(i=0; i<64; ++i)
	{			
		glPushMatrix();

		
		glTranslatef(5.12 - i*0.08, 0, 0);
		glScalef(0,0.1 + device->getSpectrumVal(i)*10,0.1 + device->getSpectrumVal(i)*10 );
		
		glMaterialfv(GL_FRONT, GL_EMISSION, mat_emission);
		glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_transparent);
		glEnable (GL_BLEND);
		glDepthMask (GL_FALSE);
		glBlendFunc (GL_SRC_ALPHA, GL_ONE);

		glutSolidSphere(1,20,20);

		glDepthMask (GL_TRUE);
		glDisable (GL_BLEND);
				

		glPopMatrix();
	}






	//central sphere reacts to Vu


	glPushMatrix();

	glMaterialfv(GL_FRONT, GL_EMISSION, mat_emission);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_transparent);
	glEnable (GL_BLEND);
	glDepthMask (GL_FALSE);
	glBlendFunc (GL_SRC_ALPHA, GL_ONE);

	glutSolidSphere(device->getVu()/3,20,20);

	glDepthMask (GL_TRUE);
	glDisable (GL_BLEND);
	

	glPopMatrix();

	
}




//-----------------------------------------------
//code to draw second visuals
//-----------------------------------------------


c_visuals_02::c_visuals_02()
{
	rotate = 0;
}


void c_visuals_02::runVisual(c_driver *device)
{

	//circle of lines representing spectrum

	glPushMatrix();
	
	glRotatef(-rotate,0,0,1);
		
	for(int j = 0; j < 36 ;j++)
	{
		
		glRotatef(j*10,0,0,1);	
		
		glBegin(GL_LINE_STRIP);	
		
		for(float i = 0; i < 256; i++)
		{
			GLfloat mat_solid[] = { 1- i/64, 0.0, i/64, 1.0 };
			GLfloat mat_zero[] = { 0.0, 0.0, 0.0, 1.0 };			
			
			glMaterialfv(GL_FRONT, GL_EMISSION, mat_zero);
			glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_solid);		
			
			glNormal3f(0,0,1);
			glVertex3f( -i*0.02,device->getSpectrumVal(i)*3,0);
		}
		glEnd();

	}

	
	glPopMatrix();




	glPushMatrix();

	glRotatef(rotate,1,0,0);
	
	glRotatef(90,1,0,0);
	
	for(int j = 0; j < 36 ;j++)
	{
		
		
		glRotatef(j*10,0,0,1);	
		
		glBegin(GL_LINE_STRIP);	
		
		for(float i = 0; i < 256; i++)
		{
			GLfloat mat_solid[] = { 1- i/64, 0.0, i/64, 1.0 };
			GLfloat mat_zero[] = { 0.0, 0.0, 0.0, 1.0 };			
			
			glMaterialfv(GL_FRONT, GL_EMISSION, mat_zero);
			glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_solid);		
			
			glNormal3f(0,0,1);
			glVertex3f( -5.12 + i*0.02,device->getSpectrumVal(i)*3,0);
		}
		glEnd();

	}

	
	glPopMatrix();




	glPushMatrix();

	glRotatef(rotate,0,1,0);
	
	glRotatef(90,0,1,0);
	
	for(int j = 0; j < 36 ;j++)
	{
		glRotatef(j*10,0,0,1);	
		
		glBegin(GL_LINE_STRIP);	
		
		for(float i = 0; i < 256; i++)
		{
			GLfloat mat_solid[] = { 1- i/64, 0.0, i/64, 1.0 };
			GLfloat mat_zero[] = { 0.0, 0.0, 0.0, 1.0 };			
			
			glMaterialfv(GL_FRONT, GL_EMISSION, mat_zero);
			glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_solid);		
			
			glNormal3f(0,0,1);
			glVertex3f( -5.12 + i*0.02,device->getSpectrumVal(i)*3,0);
		}
		glEnd();

	}

	
	glPopMatrix();

	
	//-------------------------------------------
	//TRANSPARENT
	//-------------------------------------------
	
	//row of ovoid shapes reacting to spectrum

	for(int i=0; i<64; ++i)
	{			
		glPushMatrix();

		GLfloat mat_transparent[] = { 0.8, 0.0, 0.0, 0.6 };
		GLfloat mat_emission[] = { 0.0, 0.0, 0.3, 0.6 };

		glRotatef(rotate,1,0,0);

		glTranslatef(0, 0, - i*0.16);
		glScalef(2 + device->getSpectrumVal(i)*10,1,1);
		
		glMaterialfv(GL_FRONT, GL_EMISSION, mat_emission);
		glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_transparent);
		
		glEnable (GL_BLEND);
		glDepthMask (GL_FALSE);

		glBlendFunc (GL_SRC_ALPHA, GL_ONE);

		glutSolidSphere(.1,20,20);

		glDepthMask (GL_TRUE);
		glDisable (GL_BLEND);

		glPopMatrix();
		  
	}

	
	
	for(int i=0; i<64; ++i)
	{			
		glPushMatrix();

		GLfloat mat_transparent[] = { 0.8, 0.0, 0.0, 0.6 };
		GLfloat mat_emission[] = { 0.0, 0.0, 0.3, 0.6 };
		
		glRotatef(rotate,1,0,0);
		
		glTranslatef( 0, 0, i*0.16);
		glScalef(2 + device->getSpectrumVal(i)*10,1,1);
		
		glMaterialfv(GL_FRONT, GL_EMISSION, mat_emission);
		glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_transparent);

		glEnable (GL_BLEND);
		glDepthMask (GL_FALSE);

		glBlendFunc (GL_SRC_ALPHA, GL_ONE);

		glutSolidSphere(.1,20,20);

		glDepthMask (GL_TRUE);
		glDisable (GL_BLEND);
				

		glPopMatrix();
	}
	


		//row of ovoid shapes reacting to spectrum

	for(int i=0; i<64; ++i)
	{			
		glPushMatrix();

		GLfloat mat_transparent[] = { 0.8, 0.0, 0.0, 0.6 };
		GLfloat mat_emission[] = { 0.0, 0.0, 0.3, 0.6 };

		glRotatef(rotate,0,1,0);

		glTranslatef( - i*0.16, 0, 0);
		glScalef(1,2 + device->getSpectrumVal(i)*10,1);
		
		glMaterialfv(GL_FRONT, GL_EMISSION, mat_emission);
		glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_transparent);
		
		glEnable (GL_BLEND);
		glDepthMask (GL_FALSE);

		glBlendFunc (GL_SRC_ALPHA, GL_ONE);

		glutSolidSphere(.1,20,20);

		glDepthMask (GL_TRUE);
		glDisable (GL_BLEND);

		glPopMatrix();
		  
	}

	
	
	for(int i=0; i<64; ++i)
	{			
		glPushMatrix();

		GLfloat mat_transparent[] = { 0.8, 0.0, 0.0, 0.6 };
		GLfloat mat_emission[] = { 0.0, 0.0, 0.3, 0.6 };
		
		glRotatef(rotate,0,1,0);
		
		glTranslatef( i*0.16, 0, 0);
		glScalef(2 + device->getSpectrumVal(i)*10,1,1);
		
		glMaterialfv(GL_FRONT, GL_EMISSION, mat_emission);
		glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_transparent);

		glEnable (GL_BLEND);
		glDepthMask (GL_FALSE);

		glBlendFunc (GL_SRC_ALPHA, GL_ONE);

		glutSolidSphere(.1,20,20);

		glDepthMask (GL_TRUE);
		glDisable (GL_BLEND);
				

		glPopMatrix();
	}
	
	
	
	
	
	//increase rotate value
	rotate+=1;

	//central sphere reacts to Vu

	glPushMatrix();

	GLfloat mat_transparent[] = { 0.8, 0.0, 0.0, 0.6 };
	GLfloat mat_emission[] = { 0.0, 0.0, 0.3, 0.6 };

	glMaterialfv(GL_FRONT, GL_EMISSION, mat_emission);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_transparent);
	glEnable (GL_BLEND);
	glDepthMask (GL_FALSE);
	glBlendFunc (GL_SRC_ALPHA, GL_ONE);

	glutSolidSphere(device->getVu()/3,20,20);

	glDepthMask (GL_TRUE);
	glDisable (GL_BLEND);
	

	glPopMatrix();




}