#include <iostream> 
#include <string> 
#include <stdlib.h>

// define the command line argument parameters : indicates 2nd arg
#define ARGUMENTS "vdhf:"



using std::cout;	using std::endl;
using std::string;

int main(int argc, char *argv[])
{
	
	// define some inital global variables for the program
	bool Verbose = false;
	bool Debug = false;
	bool Help = false;
	
	// pointer to hold the string from the command line
	string Argument;
	
	// the character returned from the getopt function
	char c;
	
	
	// now loop and parse the command line options
	while( (c=getopt(argc,argv,ARGUMENTS)) !=EOF)
	{
		switch(c) // which option has been chosen
		{
			case 'v' : // -v
			cout << "Setting Verbose Mode" << endl;
			Verbose = true;
			break;
			
			case 'd' : // -d
			cout << "Setting Debug Mode" << endl;
			Debug = true;
			break;
			
			case 'h' : //-h
			cout << "Help Mode" << endl;
			Help=true;
			break;
			
			case 'f' : // -f [ARG]
			cout << "passing an argument The argument is " << optarg << endl;
			Argument = optarg;
			break;
			
			case '?' : // unknown option report this and exit
			// where optopt is the current option
			cout << "Unknown argument " << optopt;
			cout << "Valid arguments are -v -d -h -f [name]" << endl;
			cout << "Will now exit" << endl;
			exit(EXIT_FAILURE);
			break;
		}
	}
	
	cout << "Argument parsed current modes are as follows" << endl;
	cout << "Debug = " << Debug << endl;
	cout << "Verbose = " << Verbose << endl;
	cout << "Help = " << Help << endl;
	cout << "Argument passed is " << Argument << endl;
		
	
	
	return EXIT_SUCCESS;
}


